//------------------------------------------------------------------------------
//
//  Thing Without A Name
//
//  Author: Bonsai (mail: bonsai@b0n541.net)
//
//  Copyright: GNU General Public License 
//
//------------------------------------------------------------------------------

#include "colors.inc"  // Is needed for woods.inc
#include "woods.inc"   // Standard woods.inc that comes with the POV-Ray package

background
        {
        color rgb <0, 0, 0>
        }

camera
        {
        location <80, 80, -80>
        look_at <10, 10, 10>
        angle 20
        }

light_source
        {
        <80, 100, -100>
        color rgb <1, 1, 1>
        spotlight 
        radius 10
        falloff 20
        tightness 0.5
        point_at <10, 10, 10>
        }

plane
        {
        <0, 1, 0>, -0.25
        
        texture
                {
                T_Wood8
                pigment
                        {
                        turbulence 0.1
                        }
                finish
                        {
                        ambient 0.3
                        reflection 0.2
                        }

                scale 20
                rotate <5, 25, 0>
                translate <5, 0 ,0>
                }
        }

// One side of the cube
#declare Side =
        union
                {
                #declare length = 20;         // Length of the sides of the cube
                #declare no_of_sticks = 15;   // No. of sticks on each part of a side
                #declare thick = 0.25;        // Thickness of the sticks
                
                // The four edges of one side
                sphere {<0, 0, 0>, thick}            
                sphere {<0, length, 0>, thick}
                sphere {<length, 0, 0>, thick}
                sphere {<length, length, 0>, thick}
                
                // The sticks on the side
                #declare i = 0;
                #while (i < length + 1)
                        //Part one (half side)
                        cylinder
                                {
                                <0, 0 + i, 0>,
                                <0 + i, length, 0>,
                                thick
                                }
                        //Part two (other half)
                        cylinder
                                {
                                <0 + i, 0, 0>,
                                <length, 0 + i, 0>,
                                thick
                                }
                        #declare i = i + length / no_of_sticks;
                #end
                }                

// Bringing together all six sides        
union
        {
        object { Side }
        object { Side rotate <0, -90,   0> }
        object { Side rotate <0,   0,  90> translate <length,  0, length> }
        object { Side rotate <0, -90, 180> translate <length, length,  0> }
        object { Side rotate <90,  0,   0> }
        object { Side rotate <90, 90,   0> translate < 0, length, length> }

        texture
                {
                pigment
                        {
                        color rgb <1, 1, 0>
                        }
                finish
                        {
                        ambient 0.2
                        phong 1
                        phong_size 50
                        }
                }
        }